Program DMM; {program pro obsluhu digitalniho voltmetru}
Uses crt;
var ba:word; {bazova adresa portu}
    ch:char; {znak z klavesnice}
    rozsah:word; {rozsah mereneho napeti ve voltech}
    dm:byte; {pocet desetinnych mist pro zobrazovani namerenych hodnot}

procedure tKurzorVyp; assembler; {vypne textovy kurzor}
Asm
mov AH,1
mov CX,$1000
int $10
End;{tkurzorvyp}

procedure tKurzorZap; assembler; {zapne textovy kurzor}
Asm
mov AH,1
mov CX,$0607
int $10
End;{tkurzorzap}

procedure VynulujPort; {vypne vsechny vystupy portu}
Begin
Port[ba+4]:=0; {DTR a RTS}
Port[ba+3]:=0; {TXD}
End;{vynulujport}

function AD:byte; {spusti A/D prevod a vrati namerenou hodnotu napeti}
var a,b,m:byte;
Begin
inline($FA); {cli - zakaz preruseni, aby nam neco nerozhodilo cekaci smycky}
Port[ba+4]:=2; {zapni RTS - signal pro zacatek mereni napeti}
for a:=1 to 20 do ; {chvilka cekani, aby se napeti stihlo zmerit}
Port[ba+4]:=0; {vypni RTS - signal pro odeslani prvniho bitu namerene hodnoty}
for a:=1 to 2 do ; {chvilka cekani}
m:=0;
for b:=1 to 8 do begin
                 m:=(m shl 1) or ((port[ba+6] shr 4) and 1); {bity prichazeji linkou CTS, postupne od nejvyssiho}
                 Port[ba+4]:=1; {zapni DTR - signal pro odeslani dalsiho bitu}
                 for a:=1 to 2 do ;
                 Port[ba+4]:=0;
                 end;
inline($FB); {sti - zase povol preruseni}
AD:=m;
End;{AD}

procedure VyberPort; {necha uzivatele vybrat seriovy port}
Begin
clrscr;
gotoxy(25,2);
write('<<C>2010> VAGNER VLASTIMIL');
gotoxy(22,4);
write('Vyber port pro pripojeni voltmetru:');
gotoxy(22,6);
write('<1>COM1; <2>COM2; <3>COM3; <4>COM4');
case readkey of '2':ba:=$2F8;
                '3':ba:=$3E8;
                '4':ba:=$2E8;
                else ba:=$3F8; {v pripade preklepu se bere COM1}
                end;
End;{vyberport}

BEGIN
tkurzorvyp;
textbackground(white);
textcolor(black);
vyberport;
vynulujport;
clrscr;
gotoxy(13,3);
write('Zvol rozsah <D>o 5 V, <N>ad 5 V nebo <ESC> pro ukonceni!');
 repeat
 ch:=upcase(readkey);
 if ch='D' then begin rozsah:=5;  dm:=3; end
           else begin rozsah:=50; dm:=2; end;
 if ch<>#27 then begin
                 gotoxy(30,6);
                 write('Zvoleno mereni do ',rozsah,' V ');
                  repeat
                  gotoxy(33,8);
                  write('Napeti = ',(AD*rozsah)/255:3:3,' V ');
                  delay(200);
                  until KeyPressed;
                 end;
 until ch=#27;
vynulujport;
normvideo;
tkurzorzap;
clrscr;
END.
