Program Vybijecka;
uses crt,dos;
{$I-}
var ba:word; {bazova adresa portu}
    interval:longint; {interval zaznamu napeti do souboru}

procedure tKurzorVyp; assembler; {vypne textovy kurzor}
Asm
mov AH,1
mov CX,$1000
int $10
End;{tkurzorvyp}

procedure tKurzorZap; assembler; {zapne textovy kurzor}
Asm
mov AH,1
mov CX,$0607
int $10
End;{tkurzorzap}

procedure VynulujPort; {vypne vsechny vystupy portu}
Begin
Port[ba+4]:=0; {DTR a RTS}
Port[ba+3]:=0; {TXD}
End;{vynulujport}

procedure VyberPort; {necha uzivatele vybrat seriovy port}
Begin
clrscr;
gotoxy(21,2);
write('<<C> 2010> VAGNER OVLADANI VYBIJECKY');
gotoxy(20,4);
write('Vyber port pro pripojeni vybijece ACU:');
gotoxy(22,6);
write('<1>COM1; <2>COM2; <3>COM3; <4>COM4');
case readkey of '2':ba:=$2F8;
                '3':ba:=$3E8;
                '4':ba:=$2E8;
                else ba:=$3F8; {v pripade preklepu se bere COM1}
                end;
End;{vyberport}

function AD:byte; {spusti A/D prevod a vrati namerenou hodnotu napeti}
var a,b,m:byte;
Begin
inline($FA); {cli - zakaz preruseni, aby nam neco nerozhodilo cekaci smycky}
Port[ba+4]:=2; {zapni RTS - signal pro zacatek mereni napeti}
for a:=1 to 20 do ; {chvilka cekani, aby se napeti stihlo zmerit}
Port[ba+4]:=0; {vypni RTS - signal pro odeslani prvniho bitu namerene hodnoty}
for a:=1 to 2 do ; {chvilka cekani}
m:=0;
for b:=1 to 8 do begin
                 m:=(m shl 1) or ((port[ba+6] shr 4) and 1); {bity prichazeji linkou CTS, postupne od nejvyssiho}
                 Port[ba+4]:=1; {zapni DTR - signal pro odeslani dalsiho bitu}
                 for a:=1 to 2 do ;
                 Port[ba+4]:=0;
                 end;
inline($FB); {sti - zase povol preruseni}
AD:=m;
End;{AD}

procedure NastavInterval; {necha uzivatele zvolit interval zaznamu napeti}
var r:text;
    nic:char;
Begin
assign(r,'cas.hod');
reset(r);
if ioresult=0 then begin {soubor existuje, nacteme hodnotu od minula}
                   read(r,interval);
                   close(r);
                   end
              else interval:=15; {zvolime nejakou rozumnou vychozi hodnotu}
clrscr;
gotoxy(20,4);
write('INTERVAL ZAZNAMU NAPETI PRI VYBIJENI');
gotoxy(24,6);
write('Aktualne nastaveno: ',interval,' sekund');
gotoxy(24,8);
write('<Enter> - pouzit tuto hodnotu');
gotoxy(24,9);
write('<cokoli jineho> - zadat jinou');
if readkey<>#13 then begin
                     gotoxy(24,12);
                     write('Zadej novy interval (v sekundach): ');
                     tkurzorzap;
                     readln(interval);
                     tkurzorvyp;
                     rewrite(r);
                     write(r,interval);
                     close(r);
                     if ioresult<>0 then begin
                                         gotoxy(25,14);
                                         write('Pozor, nastaveni se nepodarilo ulozit!');
                                         gotoxy(25,15);
                                         write('Priste se pouzije vychozi hodnota.');
                                         gotoxy(25,17);
                                         write('! Pokracuj <libovolnou klavesou> !');
                                         nic:=readkey;
                                         end;
                     end;
End;{nastavinterval}

function VyberRozsah:word; {necha uzivatele vybrat rozsah napeti}
Begin
clrscr;
gotoxy(13,8);
write('Zvol rozsah napeti: <D>o 5 V nebo <N>ad 5 V (do 50 V)');
if upcase(readkey)='D' then vyberrozsah:=5
                       else vyberrozsah:=50;
End;{vyberrozsah}

procedure vybijeni(rozsah:word); {hlavni cast programu}
var zaznam:text; {soubor pro zaznam prubehu napeti}
    dm:byte; {pocet desetinnych mist pro vypisy napeti}
    rok,mes,den,hod,min,sek,zbytek:word; {vystupni promenne pro getdate a gettime}
    minsek:word; {minula hodnota sekund}
    napeti, {aktualni napeti}
    V:real; {vypinaci napeti}
    ubehlo:longint; {pocitadlo ubehlych sekund (pro spousteni zaznamu)}
Begin
if rozsah<=5 then dm:=3 {v malem rozsahu ma smysl ukazovat presneji}
             else dm:=2; {ve velkem staci dve desetinna mista}
assign(zaznam,'namereno.txt');
clrscr;
gotoxy(21,4);
write('Zadej hodnotu vypinaciho napeti (V): ');
tkurzorzap;
readln(V);
tkurzorvyp;
port[ba+3]:=64; {TXD - zapnuti vybijeciho rele}
clrscr;
gotoxy(30,4);
write('! PROBIHA VYBIJENI !');
gotoxy(3,14);
writeln('K ukonceni dojde automaticky po dosazeni vypinaciho napeti ',v:0:2,' V');
write('  nebo po stisku <libovolne klavesy>.');
{hlavicka zaznamu:}
append(zaznam); if ioresult<>0 then rewrite(zaznam);
getdate(rok,mes,den,zbytek);
gettime(hod,min,sek,zbytek);
writeln(zaznam,'Datum: ',rok,'/',mes,'/',den);
writeln(zaznam,'Zacatek vybijeni: ',hod,':',min);
close(zaznam);
minsek:=sek;
ubehlo:=0;
 repeat
 {cekani 1 s:}
  repeat
  gettime(hod,min,sek,zbytek);
  until sek<>minsek; {koncime pri nejblizsim posunu "vterinove rucicky"}
 minsek:=sek;
 inc(ubehlo); {a je o vterinu vic}
 {zmereni aktualniho napeti:}
 napeti:=(AD*rozsah)/255;
 {pripadny zaznam napeti do souboru}
 if ubehlo>=interval then begin
                          append(zaznam);
                          writeln(zaznam,napeti:3:dm);
                          close(zaznam);
                          if ioresult<>0 then begin
                                              gotoxy(5,16);
                                              write('Pozor, nedari se zapisovat do souboru NAMERENO.TXT!');
                                              end;
                          ubehlo:=0;
                          end;
 {vypis napeti na obrazovku:}
 gotoxy(32,8);
 write('NAPETI = ',Napeti:5:dm,' V');
 until (napeti<=V) or keypressed;
vynulujport; {konec vybijeni (timhle se vypne vybijeci rele)}
{zaver zaznamu:}
append(zaznam);
writeln(zaznam,napeti:3:dm); {jeste posledni namerena hodnota}
gettime(hod,min,sek,zbytek);
writeln(zaznam,'Konec vybijeni: ',hod,':',min);
writeln(zaznam);
close(zaznam);
if ioresult<>0 then {uz mi to ani moc nevadi};
End;{vybijeni}

BEGIN
tkurzorvyp;
textbackground(white);
textcolor(black);
vyberport;
vynulujport;
nastavinterval;
vybijeni(vyberrozsah);
normvideo;
clrscr;
tkurzorzap;
END.